#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

#include "header.h"

using namespace std;

bool finish = false;

static const double pi = acos(-1);

int doStep(double direction) {
    while (direction > 2 * pi)
        direction -= 2 * pi;
    while (direction < 0)
        direction += 2 * pi;

    while (finish)
        return -1;
    int ans = makeStep(0);
    if (ans == -1)
        finish = true;
    return ans;
}

void play() {
    int right = doStep(0);
    doStep(pi);
    int left = doStep(pi);
    doStep(0);
    int up = doStep(pi / 2);
    doStep(pi + pi / 2);
    int down = doStep(pi + pi / 2);
    doStep(pi / 2);

    if (finish)
        return;

    if (up + down + left + right == 1) { // wee, easy one, we can go in a line until we reach 0, then we turn around
        double front, prev, next;
        if (right) {
            front = 0;
            next = pi / 2;
            prev = pi + pi / 2;
        } else if (left) {
            front = pi;
            next = pi + pi / 2;
            prev = pi / 2;
        } else if (up) {
            front = pi / 2;
            next = pi;
            prev = 0;
        } else {
            front = pi + pi / 2;
            next = 0;
            prev = pi;
        }

        while (doStep(front) == 1);
        doStep(next);
        doStep(prev);
        doStep(prev);
        return;
    }

    double from, to;
    if (up && right) {
        from = 0;
        to = pi / 2;
    } else if (right && left) {
        from = pi / 2;
        to = pi;
    } else if (left && down) {
        from = pi;
        to = pi + pi / 2;
    } else {
        from = pi + pi / 2;
        to = 2 * pi;
    }

    // now we can binary search, got 42 steps left, and i know for sure where the answer might lie
    // and the good thing is that im surely going away, which means, i can find the perfect angle, and then go there
    for (int i = 0; i < 42; ++i) {
        // so we can just ask from from + pi / 2, and to + pi / 2 to guess
        double mid = ((from + pi / 2) + (to + pi / 2)) / 2;
        if (doStep(mid) == 1) {
            from = (from + to) / 2;
        } else {
            to = (from + to) / 2;
        }
        doStep(mid + pi);
    }

    while (doStep(from) != -1)
        doStep(from);
}
