/**
 * Author: Andrei Heidelbacher
 * Task: Babaoarba
 * Time complexity: O(D)
 * Space complexity: O(1)
 * Expected score: 20 points
 */

#include <cmath>
#include <cassert>

#include "header.h"

using namespace std;

const double PI = acos(-1.0);

const int CLOSER = 1;
const int NOT_CLOSER = 0;
const int FINISHED = -1;

bool findStrip(double direction) {
  int q = makeStep(direction);
  if (q == FINISHED)
    return true;
  else if (q == NOT_CLOSER)
    direction += PI;
  for (q = makeStep(direction); q == CLOSER; q = makeStep(direction));
  if (q == FINISHED) {
    return true;
  } else {
    assert(makeStep(direction + PI) != FINISHED);
    return false;
  }
}

bool findSquare() {
  if (findStrip(0.0))
    return true;
  if (findStrip(PI / 2.0))
    return true;
  return false;
}

bool findPoint() {
  if (findSquare())
    return true;
  double direction = PI / 4.0;
  for (int d = 0; d < 4; ++d, direction += PI / 2.0) {
    if (makeStep(direction) == FINISHED)
      return true;
    else
      assert(makeStep(direction + PI) != FINISHED);
  }
  return false;
}

void play() {
  assert(findPoint());
}
