#include <cstdio>
#include <vector>
#include <algorithm>
#define MAXN 500005
#define MAXQ 500005
#define MAXLOGN 21
using namespace std;

int n, dad[MAXN][MAXLOGN], lvl[MAXN], nrq, sol[MAXQ][2];
int q[MAXQ];
bool colored[MAXN];
vector<int> G[MAXN];

void DFS(int u, int p) {
    int x = p;
    for(int i = 0; i < MAXLOGN; ++i) {
        dad[u][i] = x;
        x = dad[x][i];
    }
    lvl[u] = lvl[p] + 1;

    for(auto x: G[u])
        if(x != p)
            DFS(x, u);
}

int getDist(int x, int y) {
    int ans = 0;

    if(lvl[x] < lvl[y])
        swap(x, y);

    for(int i = MAXLOGN - 1; i >= 0; --i)
        if(lvl[x] - (1 << i) >= lvl[y]) {
            ans += (1 << i);
            x = dad[x][i];
        }

    if(x == y) return ans;

    for(int i = MAXLOGN - 1; i >= 0; --i)
        if(dad[x][i] != dad[y][i]) {
            x = dad[x][i];
            y = dad[y][i];
            ans += (1 << (i + 1));
        }

    return ans + 2;
}

int main() {
    freopen("maxdist.in", "r", stdin);
    freopen("maxdist.out", "w", stdout);

    scanf("%d %d", &n, &nrq);
    for(int i = 1; i < n; ++i) {
        int x, y;
        scanf("%d %d", &x, &y);
        G[x].push_back(y);
        G[y].push_back(x);
    }

    DFS(1, 0);

    for(int i = 1; i <= nrq; ++i) {
        scanf("%d", &q[i]);
        colored[q[i]] = 1;
    }

    int cnt = nrq;

    for(int i = 1; i <= n; ++i)
        if(!colored[i])
            q[++cnt] = i;

    for(int k = 0; k < 2; ++k) {
        int d1 = 0, d2 = 0, curDist = 0;
        for(int i = 1; i <= n; ++i) {
            int x = q[i];

            if(d1 == 0) d1 = x;
            else if(d2 == 0) {
                d2 = x;
                curDist = getDist(d1, d2);
            }
            else {
                int dist1 = getDist(d1, x);
                int dist2 = getDist(d2, x);
                
                if(max(dist1, dist2) > curDist) {
                    if(dist1 > dist2)
                        d2 = x;
                    else
                        d1 = x;
                    curDist = max(dist1, dist2);
                }
            }

            if(k == 0) sol[i][0] = curDist;
            else sol[n - i + 1][1] = curDist;
        }

        reverse(q + 1, q + n + 1);
    }

    for(int i = 1; i <= nrq; ++i)
        printf("%d %d\n", sol[i + 1][1], sol[i][0]);

    return 0;
}
