#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define pll pair<ll, ll>
#define pdd pair<ld, ld>
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second

const int NMAX = 500005;
const int LMAX = 20;

int n, q, lim;
int lefty, righty;
int diameter;
int node[NMAX];
int lev[NMAX];
int ans1[NMAX];
int ans2[NMAX];
int f[LMAX][NMAX];
vector<int> v[NMAX];
bitset<NMAX> colored;

void dfs(int x, int d) {
    for (auto it : v[x])
        if (it != d) {
            f[0][it] = x;
            lev[it] = lev[x] + 1;
            dfs(it, x);
        }
}

void build() {
    dfs(1, 0);

    int i, j;
    for (i = 1; (1 << i) <= n; i++)
        for (j = 1; j <= n; j++)
            f[i][j] = f[i - 1][f[i - 1][j]];

    lim = i - 1;
}

int lca(int x, int y) {
    if (lev[x] > lev[y])
        swap(x, y);

    int dif = lev[y] - lev[x];

    for (int i = 0; (1 << i) <= dif; i++)
        if ((1 << i) & dif)
            y = f[i][y];

    if (x == y)
        return x;

    for (int i = lim; i >= 0; i--)
        if (f[i][x] != f[i][y]) {
            x = f[i][x];
            y = f[i][y];
        }

    return f[0][x];
}

int dist(int x, int y) {
    return lev[x] + lev[y] - 2 * lev[lca(x, y)];
}

void add(int x) {
    if (!lefty) {
        lefty = x;
        return;
    }

    if (!righty) {
        righty = x;
        diameter = dist(lefty, righty);
        return;
    }

    int d1 = dist(x, lefty);
    int d2 = dist(x, righty);


    if (d1 >= d2 && d1 > diameter) {
        righty = x;
        diameter = d1;
    } else if (d2 > d1 && d2 > diameter) {
        lefty = x;
        diameter = d2;
    }
}

int main() {
    cin.sync_with_stdio(false);

    freopen("maxdist.in", "r", stdin);
    freopen("maxdist.out", "w", stdout);


    scanf("%d%d", &n, &q);
    for (int i = 1; i < n; i++) {
        int x, y;
        scanf("%d%d", &x, &y);
        v[x].pb(y);
        v[y].pb(x);
    }

    build();

    for (int i = 0; i < q; i++) {
        scanf("%d", &node[i]);
        colored[node[i]] = 1;
        add(node[i]);
        ans1[i] = diameter;
    }

    diameter = lefty = righty = 0;
    for (int i = 1; i <= n; i++)
        if (!colored[i]) {
            add(i);
        }

    for (int i = q - 1; i >= 0; i--) {
        ans2[i] = diameter;
        add(node[i]);
    }

    for (int i = 0; i < q; i++)
        printf("%d %d\n", ans2[i], ans1[i]);

    return 0;
}
