#include<bits/stdc++.h>

using namespace std;

#define dbg(x) (cout<<#x<<" = "<<(x)<<'\n')

typedef long long int lld;
const int INF = (1LL << 30) - 1;
const lld LINF = (1LL << 62) - 1;
const int NMAX = 3e5;
const int LMAX = 19;

int N, Q, trueQ;
vector<int> V[NMAX + 5];
bitset < NMAX + 5 > viz;
int lvl[NMAX + 5];
int dad[LMAX + 1][NMAX + 5];
int firstVertex, lastVertex, maxdist;
int colored[NMAX + 5];
int blackDist[NMAX + 5];
int whiteDist[NMAX + 5];
bitset < NMAX + 5 > isBlack;

void dfs(int);
int lca(int x, int y);
int dist(int x, int y);
void do_blacks();
void do_whites();

int main() {
	cin.sync_with_stdio(false);

	#ifndef ONLINE_JUDGE
	freopen("maxdist.in", "r", stdin);
	freopen("maxdist.out", "w", stdout);
	#endif

	scanf("%d%d", &N, &trueQ);

	for (int i = 1, x, y; i < N; i++) {
		scanf("%d%d", &x, &y);
		V[x].push_back(y);
		V[y].push_back(x);
	}

	dfs(1);
	do_blacks();
	do_whites();

	for (int i = 1; i <= trueQ; i++)
		printf("%d %d\n", whiteDist[i], blackDist[i]);

	return 0;
}

void dfs(int x) {
	viz[x] = 1;

	for (auto y : V[x])
		if (!viz[y]) {
			lvl[y] = lvl[x] + 1;
			dad[0][y] = x;
			for (int i = 1; (1 << i) <= N; i++)
				dad[i][y] = dad[i - 1][dad[i - 1][y]];
			dfs(y);
		}
}

int lca(int x, int y) {
	if (lvl[x] < lvl[y]) swap(x, y);

	int d = lvl[x] - lvl[y];

	for (int i = LMAX; i >= 0; i--)
		if ((1 << i) & d)
			x = dad[i][x];

	if (x == y) return x;

	for (int i = LMAX; i >= 0; i--)
		if (dad[i][x] != dad[i][y]) {
			x = dad[i][x];
			y = dad[i][y];
		}

	return dad[0][x];
}

int dist(int x, int y) {
	return lvl[x] + lvl[y] - 2 * lvl[lca(x, y)];
}

void do_blacks() {
	Q = trueQ;

	for (int i = 1, x; i <= Q; i++) {
		scanf("%d", &x);
		colored[i] = x;
		isBlack[x] = 1;

		if (!firstVertex)
			firstVertex = lastVertex = x;

		int p = dist(x, firstVertex);
		int q = dist(x, lastVertex);

		if (max(p, q) > maxdist) {
			if (p > q) {
				lastVertex = x;
				maxdist = p;
			} else {
				firstVertex = x;
				maxdist = q;
			}
		}

		blackDist[i] = maxdist;
	}
}

void do_whites() {
	for (int i = 1; i <= N; i++)
		if (!isBlack[i])
			colored[++Q] = i;

	firstVertex = lastVertex = maxdist = 0;

	for (int i = N, x; i >= 1; i--) {
		x = colored[i];

		if (!firstVertex)
			firstVertex = lastVertex = x;

		int p = dist(x, firstVertex);
		int q = dist(x, lastVertex);

		whiteDist[i] = maxdist;

		if (max(p, q) > maxdist) {
			if (p > q) {
				lastVertex = x;
				maxdist = p;
			} else {
				firstVertex = x;
				maxdist = q;
			}
		}
	}
}
