#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
using namespace std;

const int nmax = 500010;

int n, m, a, b, q[nmax], maxblack[nmax], maxwhite[nmax];
vector<int> g[nmax];
int level[nmax], anc[20][nmax];
bool used[nmax], usedquery[nmax];

void dfs(int node, int father)
{
	used[node] = 1;
	level[node] = level[father] + 1;
	anc[0][node] = father;

	for (int i = 0; i < g[node].size(); ++ i)
	{
		int vec = g[node][i];
		if (!used[vec])
			dfs(vec, node);
	}
}

void buildAnc()
{
	for (int i = 1; (1 << i) <= n; ++ i)
		for (int j = 1; j <= n; ++ j)
			anc[i][j] = anc[i - 1][anc[i - 1][j]];
}

int getLCA(int x, int y)
{
	if (level[x] < level[y]) swap(x, y);

	for (int i = 19; i >= 0; -- i)
		if (level[x] - (1 << i) >= level[y])
			x = anc[i][x];
	if (x == y) return x;
	for (int i = 19; i >= 0; -- i)
		if (anc[i][x] && anc[i][x] != anc[i][y])
			x = anc[i][x], y = anc[i][y];
	return anc[0][x];
}

int getDist(int x, int y)
{
	int lca = getLCA(x, y);
	return level[x] + level[y] - 2 * level[lca];
}

void solve(int distVec[nmax])
{
	int node1 = -1, node2 = -1, crtMax = 0;

	for (int i = 1; i <= m; i ++)
	{
		if (node1 == -1) node1 = q[i];
		else if (node2 == -1) node2 = q[i], crtMax = getDist(node1, node2);
		else 
		{
			int dist1 = getDist(q[i], node1), dist2 = getDist(q[i], node2);
			int nextNode1 = node1, nextNode2 = node2;
			if (dist1 > crtMax)
				crtMax = dist1, nextNode1 = node1, nextNode2 = q[i];
			if (dist2 > crtMax)
				crtMax = dist2, nextNode1 = q[i], nextNode2 = node2;
			node1 = nextNode1;
			node2 = nextNode2;
		}
		distVec[i] = crtMax;
	}
}

int main()
{
	freopen("maxdist.in", "r", stdin);
	freopen("maxdist.out", "w", stdout);

	scanf("%i %i", &n, &m);
	for (int i = 1; i < n; ++ i)
	{
		scanf("%i %i", &a, &b);
		g[a].push_back(b);
		g[b].push_back(a);
	}

	for (int i = 1; i <= m; ++ i)
		scanf("%i", &q[i]), usedquery[q[i]] = 1;

	dfs(1, 0);
	buildAnc();

	int oldm = m;

	for (int i = 1; i <= n; ++ i)
		if (!usedquery[i])
			q[++ m] = i;

	solve(maxblack);
	reverse(q + 1, q + m + 1);
	solve(maxwhite);
	reverse(maxwhite + 1, maxwhite + m + 1);

	for (int i = 1; i <= oldm; ++ i)
		printf("%i %i\n", maxwhite[i + 1], maxblack[i]);

	return 0;
}
