#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pb push_back
#define mp make_pair
#define pii pair<int, int>
#define pll pair<ll, ll>
#define pdd pair<ld, ld>
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second

const int NMAX = 1e5 + 5;
const int INF = 1 << 29;

int n, sol, YMAX;
int x[NMAX], y[NMAX];
int ind[NMAX];
pair<pii, int> v[NMAX];
vector<int> seg[4 * NMAX], yseg[4][4 * NMAX];
vector<bool> viz[4 * NMAX];

void update_y(int where, int vertex, int node, int l, int r, int pos, int val) {
    if (l == r) {
        yseg[where][vertex][node] = val;
        return;
    }

    int m = (l + r) / 2;
    int ls = 2 * node;
    int rs = 2 * node + 1;

    if (pos <= m) {
        update_y(where, vertex, ls, l, m, pos, val);
    } else {
        update_y(where, vertex, rs, m + 1, r, pos, val);
    }

    yseg[where][vertex][node] = min(yseg[where][vertex][ls], yseg[where][vertex][rs]);
}

int query_y(int where, int vertex, int node, int l, int r, int a, int b) {
    if (l >= a && r <= b) {
        return yseg[where][vertex][node];
    }

    int m = (l + r) / 2;
    int ls = 2 * node;
    int rs = 2 * node + 1;

    int ans = INF;
    if (a <= m)
        ans = min(ans, query_y(where, vertex, ls, l, m, a, b));
    if (b > m)
        ans = min(ans, query_y(where, vertex, rs, m + 1, r, a, b));

    return ans;
}

void build(int node, int l, int r) {
    if (l == r) {
        seg[node].pb(v[l].fi.se);
        viz[node].resize(seg[node].size());

        for (int i = 0; i < 4; i++) {
            yseg[i][node].resize(4 * seg[node].size() + 5);
            for (int j = 0; j < yseg[i][node].size(); j++)
                yseg[i][node][j] = INF;
        }

        return;
    }

    int m = (l + r) / 2;
    int ls = 2 * node;
    int rs = 2 * node + 1;

    build(ls, l, m);
    build(rs, m + 1, r);

    seg[node].resize(seg[ls].size() + seg[rs].size());
    viz[node].resize(seg[ls].size() + seg[rs].size());

    for (int i = 0; i < 4; i++) {
        yseg[i][node].resize(4 * seg[node].size() + 5);
        for (int j = 0; j < yseg[i][node].size(); j++)
            yseg[i][node][j] = INF;
    }

    merge(seg[ls].begin(), seg[ls].end(), seg[rs].begin(), seg[rs].end(), seg[node].begin());
}

void update(int node, int l, int r, int pos, int x, int y) {
    int lefty = lower_bound(seg[node].begin(), seg[node].end(), y) - seg[node].begin();
    int righty = upper_bound(seg[node].begin(), seg[node].end(), y) - seg[node].begin() - 1;
    int where = -1;
    while (lefty <= righty) {
        int middle = (lefty + righty) / 2;
        if (viz[node][middle]) {
            lefty = middle + 1;
        } else {
            where = righty;
            righty = middle - 1;
        }
    }

    viz[node][where] = 1;
    update_y(0, node, 1, 1, seg[node].size(), where + 1, x + y);
    update_y(1, node, 1, 1, seg[node].size(), where + 1, -x + y);
    update_y(2, node, 1, 1, seg[node].size(), where + 1, -x - y);
    update_y(3, node, 1, 1, seg[node].size(), where + 1, x - y);

    if (l == r)
        return;

    int m = (l + r) / 2;
    int ls = 2 * node;
    int rs = 2 * node + 1;

    if (pos <= m)
        update(ls, l, m, pos, x, y);
    else
        update(rs, m + 1, r, pos, x, y);
}

int query(int where, int node, int l, int r, int X1, int X2, int Y1, int Y2) {
    if (l >= X1 && r <= X2) {
        int lefty = lower_bound(seg[node].begin(), seg[node].end(), Y1) - seg[node].begin();
        int righty = upper_bound(seg[node].begin(), seg[node].end(), Y2) - seg[node].begin() - 1;

        if (lefty > righty)
            return INF;

        return query_y(where, node, 1, 1, seg[node].size(), lefty + 1, righty + 1);
    }

    int m = (l + r) / 2;
    int ls = 2 * node;
    int rs = 2 * node + 1;

    int ans = INF;
    if (X1 <= m)
        ans = min(ans, query(where, ls, l, m, X1, X2, Y1, Y2));
    if (X2 > m)
        ans = min(ans, query(where, rs, m + 1, r, X1, X2, Y1, Y2));

    return ans;
}

int main() {
    cin.sync_with_stdio(false);

    /* freopen("mindist.in", "r", stdin); */
    /* freopen("mindist.out", "w", stdout); */

    ifstream cin("mindist.in");
    ofstream cout("mindist.out");

    /* scanf("%d", &n); */
    cin >> n;

    for (int i = 1; i <= n; i++) {
        /* scanf("%d%d", &x[i], &y[i]); */
        cin >> x[i] >> y[i];
        YMAX = max(YMAX, y[i]);
        v[i] = mp(mp(x[i], y[i]), i);
    }

    sort(v + 1, v + n + 1);
    build(1, 1, n);

    for (int i = 1; i <= n; i++) {
        ind[v[i].se] = i;
    }

    for (int i = 1; i <= n; i++) {
        sol = INF;

        int l = 1;
        int r = n;
        int low;
        while (l <= r) {
            int mi = (l + r) / 2;
            if (v[mi].fi.fi < x[i]) {
                l = mi + 1;
            } else {
                r = mi - 1;
                low = mi;
            }
        }

        l = 1;
        r = n;
        int up;
        while (l <= r) {
            int mi = (l + r) / 2;
            if (v[mi].fi.fi <= x[i]) {
                up = mi;
                l = mi + 1;
            } else {
                r = mi - 1;
            }
        }

        sol = min(sol, -x[i] - y[i] + query(0, 1, 1, n, low, n, y[i], YMAX));
        sol = min(sol, x[i] - y[i] + query(1, 1, 1, n, 1, up, y[i], YMAX));
        sol = min(sol, x[i] + y[i] + query(2, 1, 1, n, 1, up, 1, y[i]));
        sol = min(sol, -x[i] + y[i] + query(3, 1, 1, n, low, n, 1, y[i]));

        if (i == 1) sol = 0;
        /* printf("%d\n", sol); */
        cout << sol << '\n';

        update(1, 1, n, ind[i], x[i], y[i]);
    }

    return 0;
}
