#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <cassert>
using namespace std;

#define leftson (2 * node)
#define rightson (2 * node + 1)

const int nmax = 100010, cmax = 100000, inf = 0x3f3f3f3f;

int n, type, x, y;

struct DAint
{
	DAint *left, *right;
	int minsum, maxsum, mindif, maxdif;

	DAint() 
	{
		left = right = NULL;
		minsum = mindif = inf;
		maxsum = maxdif = -inf;
	}
};

DAint *root[4 * cmax], *auxNode;

void updateNode(DAint *to, DAint *from)
{
	if (from == NULL) return ;
	to -> minsum = min(to -> minsum, from -> minsum);
	to -> maxsum = max(to -> maxsum, from -> maxsum);
	to -> mindif = min(to -> mindif, from -> mindif);
	to -> maxdif = max(to -> maxdif, from -> maxdif);
}

void insDAint(DAint *node, int left, int right, int x, int y)
{
	if (left == right)
	{
		node -> minsum = min(node -> minsum, x + y);
		node -> maxsum = max(node -> maxsum, x + y);
		node -> mindif = min(node -> mindif, x - y);
		node -> maxdif = max(node -> maxdif, x - y);
		return ;
	}
	int mid = (left + right) / 2;

	if (y <= mid) 
	{
		if (node -> left == NULL) node -> left = new DAint;
		insDAint(node -> left, left, mid, x, y);
	}else 
	{
		if (node -> right == NULL) node -> right = new DAint;
		insDAint(node -> right, mid + 1, right, x, y);
	}

	updateNode(node, node -> left);
	updateNode(node, node -> right);
}

void insAint(int node, int left, int right, int x, int y)
{
	insDAint(root[node], 1, cmax, x, y);
	if (left == right) return ;

	int mid = (left + right) / 2;
	if (x <= mid) insAint(leftson, left, mid, x, y);
	else insAint(rightson, mid + 1, right, x, y);
}

void queryDAint(DAint *node, int left, int right, int ymin, int ymax)
{
	if (ymin <= left && right <= ymax)
	{
		updateNode(auxNode, node);
		return ;
	}
	int mid = (left + right) / 2;
	if (ymin <= mid && node -> left != NULL)
		queryDAint(node -> left, left, mid, ymin, ymax);
	if (mid < ymax && node -> right != NULL)
		queryDAint(node -> right, mid + 1, right, ymin, ymax);
}

void queryAint(int node, int left, int right, int xmin, int xmax, int ymin, int ymax)
{
	if (xmin <= left && right <= xmax)
	{
		queryDAint(root[node], 1, cmax, ymin, ymax);
		return ;
	}
	int mid = (left + right) / 2;
	if (xmin <= mid) queryAint(leftson, left, mid, xmin, xmax, ymin, ymax);
	if (mid < xmax) queryAint(rightson, mid + 1, right, xmin, xmax, ymin, ymax);
}

int main()
{
	freopen("mindist.in", "r", stdin);
	freopen("mindist.out", "w", stdout);

	for (int i = 0; i < 4 * cmax; ++ i)
		root[i] = new DAint;

	scanf("%i", &n);
	for (int i = 1; i <= n; ++i)
	{
		scanf("%i %i", &x, &y);
			
		int mindist = inf;
		auxNode = new DAint;
		queryAint(1, 1, cmax, 1, x, y, cmax);
		if (auxNode -> maxdif != -inf) mindist = min(mindist, x - y - auxNode -> maxdif);
		delete auxNode;

		auxNode = new DAint;
		queryAint(1, 1, cmax, x, cmax, y, cmax);
		if (auxNode -> minsum != inf) mindist = min(mindist, auxNode -> minsum - (x + y));
		delete auxNode;

		auxNode = new DAint;
		queryAint(1, 1, cmax, x, cmax, 1, y);
		if (auxNode -> mindif != inf) mindist = min(mindist, auxNode -> mindif - (x - y));
		delete auxNode;

		auxNode = new DAint;
		queryAint(1, 1, cmax, 1, x, 1, y);
		if (auxNode -> maxsum != -inf) mindist = min(mindist, x + y - auxNode -> maxsum);
		delete auxNode;

		insAint(1, 1, cmax, x, y);

		if (mindist == inf) mindist = 0;
		printf("%i\n", mindist);
	}
}
