//Gemene Narcis 
#include <cstdio>
#include <vector>

const int kMaxN = 2600;
const int kMaxM = 10000;
const int kInf = 100000000;
const int NIL = -1;
const int NMAX = 52;

struct Edge {
	int v, next;
	int cap;
};

Edge l[2 * kMaxM];  
int adj[kMaxN];         

int Q[kMaxN];         
int qStart, qEnd;

int father[kMaxN];     
int edgePointer[kMaxN];
int N;


int n, w[NMAX];
int r[NMAX][NMAX], total, C[NMAX][NMAX];
std::vector < int > answer;

inline int min(const int &x, const int &y)
{
	return x <= y ? x : y;
}

inline void Read()
{
	freopen("tournament.in", "r", stdin);
	freopen("tournament.out", "w", stdout);
	scanf("%d\n", &n);
	for (int i = 1; i <= n; i++)
		scanf("%d ",&w[i]);
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
		{
			scanf("%d\n", &r[i][j]);
			total += r[i][j];
		}
	total /= 2;
}

void addEdge(const int &u, const int &v, const int &cap, const int &pos) {
	l[pos].v = v;
	l[pos].cap = cap;
	l[pos].next = adj[u];
	adj[u] = pos;
}

int BFS(const int &source, const int &sync) {
	int u, v;

	for (int i = 0; i < N; i++) {
		father[i] = NIL;
	}

	father[source] = source;
	qStart = 0;
	qEnd = 1;
	Q[0] = source;
	do {
		u = Q[qStart++];
		for (int i = adj[u]; i != NIL; i = l[i].next) {
			v = l[i].v;
			if ((father[v] == NIL) && (l[i].cap != 0)) {
				father[v] = u;
				edgePointer[v] = i;
				Q[qEnd++] = v;
			}
		}
	} while ((qStart != qEnd) && (father[sync] == NIL));

	int flow = 0;

	for (int i = adj[sync]; i != NIL; i = l[i].next) {
		v = l[i].v;

		if ((father[v] != NIL) && (l[i ^ 1].cap)) {
			father[sync] = v;                      
			edgePointer[sync] = i ^ 1;

			int minFlow = kInf;

			u = sync;

			do {
				minFlow = min(minFlow, l[edgePointer[u]].cap);
				u = father[u];
			} while (u != source);

			u = sync;

			do {
				l[edgePointer[u]].cap -= minFlow;      
				l[edgePointer[u] ^ 1].cap += minFlow;  
				u = father[u];
			} while (u != source);

			flow += minFlow;
		}
	}
	return flow;
}


inline int Flow(const int &boss,const int &maxim)
{
	int edges = 0, nodes = n;
	for (int i = 0; i < kMaxN; i++)
		adj[i] = NIL;
	for (int i = 1; i <= n; i++)
		if (i != boss)
		{
			if (w[i] > maxim)
				return -1;
			addEdge(0, i, maxim - w[i], 2 * edges);
      addEdge(i, 0, 0, 2 * edges + 1);
			edges++;
		}
	for (int i = 1; i <= n; i++)
		for (int j = i + 1; j <= n; j++)
		{
			if (i == boss || j == boss)
				continue;
			nodes++;
			C[i][j] = nodes;
			addEdge(i, nodes, kInf, 2 * edges);
			addEdge(nodes, i, 0, 2 * edges + 1);
			edges++;


			addEdge(j, nodes, kInf, 2 * edges);
      addEdge(nodes, j, 0, 2 * edges + 1);
			edges++;
		}
	nodes++;///destination
	for (int i = 1; i <= n; i++)
		for (int j = i + 1; j <= n; j++)
		{
			if (i == boss || j == boss)
				continue;
			
			addEdge(C[i][j], nodes, r[i][j], 2 * edges);
			addEdge(nodes, C[i][j], 0, 2 * edges + 1);
			edges++;
		}
	N = nodes + 1;
	int flow = 0, augment;
	do {
		augment = BFS(0, N - 1);
		flow += augment;
	} while (augment);
	return flow;
}

inline bool Solve(const int &boss)
{
	int maxim = w[boss];
	int remaining = total;
	for (int i = 1; i <= n; i++)
	{
		maxim += r[boss][i];
		remaining -= r[boss][i];
	}
	return Flow(boss,maxim)==remaining;
}

inline void Solve()
{
	for (int i = 1; i <= n; i++)
		if (Solve(i))
			answer.push_back(i-1);
}

inline void Print()
{
	printf("%d\n", answer.size());
	for (auto x : answer)
		printf("%d ",x);
}

int main()
{
	Read();
	Solve();
	Print();
	return 0;
}

