#include <bits/stdc++.h>

using namespace std;


//input:
//N K
//size_small, size_big
//N pairs, color and size
typedef double ld;

const int MAX_N = 400 + 1;
//not linker

int n, k;
int sizeA, sizeB;

bool size[MAX_N];
int color[MAX_N];

ld DP[MAX_N][MAX_N][MAX_N];
//DP[cul][a][b] = 
//in how many ways can we select *a* small socks
//and *b* big socks
//from the first *cul* buckets
//such that no two share the same color

ld q[MAX_N][MAX_N];
//q[a][b] = 
//the probability that after *(a + b)* rounds
//we have chosen *a* small socks
//and *b* big socks


ld p[MAX_N][MAX_N];
//p[a][b] = 
//the probability that after having chosen *a* small socks
//and *b* big socks,
//no two have the same color


ld tot[MAX_N][MAX_N];
//tot[a][b] = 
//in how many ways can you choose
//*a* small socks and
//*b* big socks


int cntA[MAX_N];
//cntA[cul] = how many small socks are have the color *cul*
//cntB[cul] = same story but for big socks

int cntB[MAX_N];

int A, B;
//A how many small socks there are in total
//B how many big socks


void debug(ld x[MAX_N][MAX_N]) {
  for(int i = 0; i <= A; ++i) {
    for(int j = 0; j <= B; ++j) {
      cerr << x[i][j] << " " ;
    }
    cerr << "\n";
  }
  cerr << "\n\n";
}

int main() {
  ifstream in("expected.in");
  ofstream out("expected.out");
  in >> n >> k;
  in >> sizeA >> sizeB;

  for(int i = 0; i < n; ++i) {
    in >> color[i] >> size[i];
    assert(color[i] >= 1 && color[i] <= n);
  }

  for(int i = 0; i < n; ++i) {
    if(size[i] == 0) {
      cntA[color[i]]++;
      ++A;
    } else {
      cntB[color[i]]++;
      ++B;
    }
  }

  q[0][0] = 1.0;
  for(int i = 0; i <= A; ++i) {
    for(int j = 0; j <= B; ++j) {
      ld coefA = (A - i) * sizeA,
         coefB = (B - j) * sizeB;

      q[i + 1][j] += q[i][j] * coefA / (coefA + coefB);
      q[i][j + 1] += q[i][j] * coefB / (coefA + coefB);
    }
  }
  
  tot[0][0] = 1;
  for(int i = 0; i <= A; ++i) {
    for(int j = 0; j <= B; ++j) {
      tot[i + 1][j] = tot[i][j] * (A - i);
      tot[i][j + 1] = tot[i][j] * (B - j);
    }
  }


  DP[0][0][0] = 1;
  for(int i = 0; i <= n; ++i) {
    for(int a = 0; a <= A; ++a) {
      for(int b = 0; b <= B && b + a <= k; ++b) {
        DP[i + 1][a][b]     += DP[i][a][b];
        DP[i + 1][a + 1][b] += DP[i][a][b] * (a + 1) * cntA[i + 1];
        DP[i + 1][a][b + 1] += DP[i][a][b] * (b + 1) * cntB[i + 1];
      }
    }
  }


  for(int i = 0; i <= A; ++i) {
    for(int j = 0; j <= B; ++j) {
      p[i][j] = DP[n][i][j] / tot[i][j];
    }
  }

  ld sol = 0;

  for(int i = 0; i <= A; ++i) {
    for(int j = 0; j <= B; ++j) {
      if(i + j != k)
        continue;
      sol += (1 - p[i][j]) * q[i][j];
    }
  }

  out << fixed << setprecision(20) << sol << "\n";
  cout << fixed << setprecision(20) << sol << "\n";
  return 0;
}
