#include <cstdio>
#include <map>
#define MAXN 405
using namespace std;

int n;
int cntCul[MAXN][2], nType[2];
pair<int, int> socks[MAXN];
int ncul, k;
map<int, int> colorId;
double sz[2];
double q[MAXN][MAXN], dp[MAXN][MAXN][MAXN], tot[MAXN][MAXN];

double getChoiceProb(int n0, int n1, int choice) {
    if(choice == 0) return 1.0 * n0 * sz[0] / (1.0 * n0 * sz[0] + 1.0 * n1 * sz[1]);
    return 1.0 * n1 * sz[1] / (1.0 * n0 * sz[0] + 1.0 * n1 * sz[1]);
}

double arang(int a, int b) {
    double ans = 1;

    for(int i = a - b + 1; i <= a; ++i)
        ans *= i;

    return ans;
}

int main() {
    freopen("expected.in", "r", stdin);
    freopen("expected.out", "w", stdout);

    scanf("%d %d %lf %lf", &n, &k, &sz[0], &sz[1]);

    for(int i = 1; i <= n; ++i) {
        scanf("%d %d", &socks[i].first, &socks[i].second);
        colorId[socks[i].first];
        ++nType[socks[i].second];
    }

    for(auto &colId: colorId)
        colId.second = (++ncul);

    for(int i = 1; i <= n; ++i)
        ++cntCul[colorId[socks[i].first]][socks[i].second];

    for(int i = 0; i <= nType[0]; ++i) {
        for(int j = 0; j <= nType[1]; ++j) {
            if(i == 0 && j == 0) q[i][j] = 1;
            else {
                if(i > 0) q[i][j] += q[i - 1][j] * getChoiceProb(nType[0] - i + 1, nType[1] - j, 0);
                if(j > 0) q[i][j] += q[i][j - 1] * getChoiceProb(nType[0] - i, nType[1] - j + 1, 1);
            }
        }
    }

    /*for(int i = 0; i <= nType[0]; ++i, printf("\n"))
        for(int j = 0; j <= nType[1]; ++j)
            printf("%.10f ", q[i][j]);*/

    dp[0][0][0] = 1;
    for(int cul = 1; cul <= ncul; ++cul) {
        for(int i = 0; i <= nType[0]; ++i) {
            for(int j = 0; j <= nType[1]; ++j) {
                dp[cul][i][j] = dp[cul - 1][i][j];
                if(i > 0) dp[cul][i][j] += dp[cul - 1][i - 1][j] * cntCul[cul][0] * i;
                if(j > 0) dp[cul][i][j] += dp[cul - 1][i][j - 1] * cntCul[cul][1] * j;                
            }
        }
    }

    for(int i = 0; i <= nType[0]; ++i)
        for(int j = 0; j <= nType[1]; ++j)
            tot[i][j] = arang(nType[0], i) * arang(nType[1], j);

    double sol = 0;

    for(int i = 0; i <= k; ++i)
        if(i <= nType[0] && k - i <= nType[1])
            sol += q[i][k - i] * (1 - dp[ncul][i][k - i] / tot[i][k - i]);

    printf("%.20f\n", sol);

    return 0;
}
