#include <cassert>
#include <cstdlib>
#include <ctime>
#include <fstream>
#include <algorithm>

using namespace std;

const int MAX_N = 1000;

bool comp[MAX_N + 1];
int v[MAX_N + 1];
int perm[MAX_N + 1];
int nxt[MAX_N + 1];

int main()
{
    const int N = 1000;
    const int COMPONENTS = 750;
    const int MIN_CYCLE_SIZE = 1;
    const int MAX_CYCLE_SIZE = 10;
    
    srand(time(0));
    
    // get random test with components in order
    for (int i = 1; i <= COMPONENTS - 1; i++)
        comp[i] = 1;
    random_shuffle(comp + 1, comp + N); // in the N - 1 positions
    comp[N] = 1;
    
    int last = 0;
    for (int i = 1; i <= N; i++)
        if (comp[i]) {
            int indMin = last + 1;
            int indMax = i;
            
            assert(indMax - indMin + 1 >= MIN_CYCLE_SIZE);
            
            int cycleSize = MIN_CYCLE_SIZE + rand() % min(MAX_CYCLE_SIZE - MIN_CYCLE_SIZE + 1, (indMax - indMin + 1) - MIN_CYCLE_SIZE + 1);
            
            v[indMin + cycleSize - 1] = indMin;
            for (int j = indMin; j < indMin + cycleSize - 1; j++)
                v[j] = j + 1;
            
            for (int j = indMin + cycleSize; j <= indMax; j++)
                v[j] = indMin + rand() % (j - indMin);
            
            last = i;
        }
   
    // random shuffle nodes
    for (int i = 1; i <= N; i++)
        perm[i] = i;
    random_shuffle(perm + 1, perm + N + 1);
    
    for (int i = 1; i <= N; i++)
        nxt[perm[i]] = perm[v[i]];
    
    // print test
    ofstream fout("random_test_1000_500_750.in");
    fout << N << '\n';
    for (int i = 1; i <= N; i++)
        fout << nxt[i] << '\n';
    fout.close();
}
