#include<bits/stdc++.h>

using namespace std;

#define dbg(x) (cout<<#x<<" = "<<(x)<<'\n')

typedef long long int lld;
const int INF = (1LL << 30) - 1;
const lld LINF = (1LL << 62) - 1;
const int NMAX = 1000;

int N;
int sol[NMAX + 5];
vector<int> V[NMAX + 5];
int T[NMAX + 5];
bitset < NMAX + 5 > viz;
bitset < NMAX + 5 > erased;
priority_queue<pair<pair<int, int>, int>> erasable;
int A[NMAX + 5][NMAX + 5];
int DP[NMAX + 5][NMAX + 5];

int root[NMAX + 5];
int size[NMAX + 5];
int find(int);
void unite(int, int);

int main() {
	cin.sync_with_stdio(false);

	srand(clock());

	#ifndef ONLINE_JUDGE
	freopen("politic.in", "r", stdin);
	freopen("politic.out", "w", stdout);
	#endif

	scanf("%d", &N);

	for (int i = 1, x; i <= N; i++) {
		scanf("%d", &x);
		V[x].push_back(i);
		T[i] = x;
		root[i] = i, size[i] = 1;
	}

	for (int i = 1; i <= N; i++)
		unite(T[i], i);

	for (int i = 0; i <= N; i++)
		sol[i] = N;

	for (int bulan = 1; bulan <= 1; bulan++) {
		viz = 0;
		erased = 0;

		int M = 0;

		for (int i = 1, x, y, cnt, rt; i <= N; i++)
			if (!viz[rt = find(i)]) {
				for (x = i; !viz[x]; x = T[x])
					viz[x] = 1;

				erased[x] = 1;
				for (y = T[x], cnt = 1; x != y; y = T[y], cnt++)
					erased[y] = 1;

				for (int j = 1; j < cnt; j++)
					A[rt][j] = size[rt] - j;

				for (int j = 1; j <= N; j++)
					if (find(j) == rt && erased[T[j]] && !erased[j])
						erasable.push({{V[j].size(), rand() % N}, j});

				A[rt][0] = size[rt];
				A[rt][cnt] = size[rt] - cnt - erasable.size();

				for (int j = cnt + 1; j <= size[rt]; j++) {
					x = erasable.top().second;
					erasable.pop();
					for (auto y : V[x])
						erasable.push({{V[y].size(), rand() % N}, y});
					erased[x] = 1;
					A[rt][j] = size[rt] - j - erasable.size();
				}

				M++;
				DP[M][0] = DP[M - 1][0] + size[rt];
				for (int j = 1; j <= N; j++) {
					DP[M][j] = N;
					for (int k = 0; k <= min(j, size[rt]); k++)
						DP[M][j] = min(DP[M][j], DP[M - 1][j - k] + A[rt][k]);
				}
				// for (int j = K; j >= 1; j--)
				// 	for (int k = 0; k <= min(K, size[rt]); k++)
				// 		DP[j] = min(DP[j], DP[j - k] + A[rt][k]);

				// printf("DP: ");
				// for (int j = 0; j <= K; j++)
				// 	printf("%d ", DP[M][j]);
				// printf("\n");

				// printf("%d: ", rt);
				// for (int j = 0; j <= size[rt]; j++)
				// 	printf("%d ", A[rt][j]);
				// printf("\n");

				for (int j = 1; j <= N; j++)
					if (!viz[j] && find(j) == rt)
						viz[j] = 1;
			}

		for (int j = 0; j <= N; j++)
			sol[j] = min(sol[j], DP[M][j]);
	}

	for (int j = 1; j <= N; j++)
		printf("%d\n", sol[j]);

	return 0;
}

int find(int x) {
	if (root[x] != x) root[x] = find(root[x]);
	return root[x];
}

void unite(int x, int y) {
	x = find(x), y = find(y);
	if (x == y) return;
	if (size[x] > size[y]) {
		root[y] = x;
		size[x] += size[y];
	} else {
		root[x] = y;
		size[y] += size[x];
	}
}